package com.ejie.aa00j.control;

import java.util.List;
import java.util.Locale;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.aa00j.classes.aa00jConstantes;
import com.ejie.aa00j.model.Aa00j13s01;
import com.ejie.aa00j.model.Aa00j14s01;
import com.ejie.aa00j.service.Aa00j03s01Service;
import com.ejie.aa00j.service.Aa00j06s01Service;
import com.ejie.aa00j.service.Aa00j13s01Service;
import com.ejie.aa00j.service.Aa00j14s01Service;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * Aa00j13s01Controller generated by UDA, 16-oct-2013 13:02:18.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/aa00j13s01")
public class Aa00j13s01Controller {

	private static final Logger logger = LoggerFactory
			.getLogger(Aa00j13s01Controller.class);
	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;
	@Autowired
	private Aa00j13s01Service aa00j13s01Service;

	@Autowired
	private Aa00j14s01Service caracteristicasService;

	// @Autowired
	// private Aa00j07s01Service departamentosService;
	@Autowired
	private Aa00j03s01Service edificiosService;
	@Autowired
	private Aa00j06s01Service restriccionesService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param crec13
	 *            Long
	 * @return Aa00j13s01 Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{crec13}", method = RequestMethod.GET)
	public @ResponseBody
	Aa00j13s01 get(@PathVariable Long crec13) {
		Aa00j13s01 aa00j13s01 = new Aa00j13s01();
		aa00j13s01.setCrec13(crec13);
		aa00j13s01 = this.aa00j13s01Service.find(aa00j13s01);
		Aa00j13s01Controller.logger
				.info("[GET - findBy_PK] : Obtener Aa00j13s01 por PK");
		return aa00j13s01;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Aa00j13s01> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	List<Aa00j13s01> getAll(@ModelAttribute Aa00j13s01 filterAa00j13s01) {
		Aa00j13s01Controller.logger
				.info("[GET - find_ALL] : Obtener Aa00j13s01 por filtro");
		return this.aa00j13s01Service.findAll(filterAa00j13s01, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 * 
	 * @param aa00j13s01
	 *            Aa00j13s01 Bean que contiene la informacion a modificar.
	 * @return Aa00j13s01 Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	Aa00j13s01 edit(@RequestBody Aa00j13s01 aa00j13s01) throws Exception {
		Aa00j13s01 aa00j13s01Aux = this.aa00j13s01Service.update(aa00j13s01);
		Aa00j13s01Controller.logger
				.info("[PUT] : Aa00j13s01 actualizado correctamente");
		return aa00j13s01Aux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 * 
	 * @param aa00j13s01
	 *            Aa00j13s01 Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Aa00j13s01 Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	Aa00j13s01 add(@RequestBody Aa00j13s01 aa00j13s01) throws Exception {
		Aa00j13s01 aa00j13s01Aux = this.aa00j13s01Service.add(aa00j13s01);
		Aa00j13s01Controller.logger
				.info("[POST] : Aa00j13s01 insertado correctamente");
		return aa00j13s01Aux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 * 
	 * @param crec13
	 *            Long Identificador del objeto que se desea eliminar.
	 * @return Aa00j13s01 Bean eliminado.
	 */
	@RequestMapping(value = "/{crec13}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	Aa00j13s01 remove(@PathVariable Long crec13) throws Exception {
		Aa00j13s01 aa00j13s01 = new Aa00j13s01();
		aa00j13s01.setCrec13(crec13);
		this.aa00j13s01Service.remove(aa00j13s01);
		Aa00j13s01Controller.logger
				.info("[DELETE] : Aa00j13s01 borrado correctamente");
		return aa00j13s01;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {

		// model.addAttribute("departamentos",
		// this.departamentosService.obtenerComboControlado());
		model.addAttribute("edificios",
				this.edificiosService.getListForOption(true, true));
		model.addAttribute("restricciones",
				this.restriccionesService.obtenerCombo());
		// Guardamos los parámetros estáticos en el modelo para poder
		// utilizarlos en el jsp mediante jstl
		model.addAttribute("SI", aa00jConstantes.SI);
		model.addAttribute("NO", aa00jConstantes.NO);
		model.addAttribute("SI_NO_TODAS", aa00jConstantes.SI_NO_TODAS);
		model.addAttribute("SITUACION_ALTA", aa00jConstantes.SITUACION_ALTA);
		model.addAttribute("SITUACION_BAJA", aa00jConstantes.SITUACION_BAJA);
		model.addAttribute("SITUACION_TODAS", aa00jConstantes.SITUACION_TODAS);
		Aa00j13s01Controller.logger.info("[GET - View] : aa00j13s01");
		return "recursosgenerales";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Aa00j13s01> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody
	JQGridResponseDto<Aa00j13s01> filter(
			@RequestJsonBody(param = "filter") Aa00j13s01 filterAa00j13s01,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		Aa00j13s01Controller.logger
				.info("[POST - filter] : Obtener Aa00j13s01s");
		return this.aa00j13s01Service.filter(filterAa00j13s01,
				jqGridRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Aa00j13s01> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody
	List<TableRowDto<Aa00j13s01>> search(
			@RequestJsonBody(param = "filter") Aa00j13s01 filterAa00j13s01,
			@RequestJsonBody(param = "search") Aa00j13s01 searchAa00j13s01,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		Aa00j13s01Controller.logger
				.info("[POST - search] : Buscar Aa00j13s01s");
		return this.aa00j13s01Service.search(filterAa00j13s01,
				searchAa00j13s01, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	List<String> removeMultiple(
			@RequestJsonBody(param = "filter") Aa00j13s01 filterAa00j13s01,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto)
			throws Exception {
		Aa00j13s01Controller.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Aa00j13s01s");
		this.aa00j13s01Service.removeMultiple(filterAa00j13s01,
				jqGridRequestDto, false);
		Aa00j13s01Controller.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<Aa00j13s01>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody
	JQGridResponseDto<JerarquiaDto<Aa00j13s01>> jerarquia(
			@RequestJsonBody(param = "filter") Aa00j13s01 filterAa00j13s01,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		Aa00j13s01Controller.logger
				.info("[POST - jerarquia] : Obtener Aa00j13s01s jerarquia");
		return this.aa00j13s01Service.jerarquia(filterAa00j13s01,
				jqGridRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterAa00j13s01
	 *            Aa00j13s01 Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<Aa00j13s01>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody
	JQGridResponseDto<JerarquiaDto<Aa00j13s01>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Aa00j13s01 filterAa00j13s01,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		Aa00j13s01Controller.logger
				.info("[POST - jerarquia] : Obtener Aa00j13s01s jerarquia - Hijos");
		return this.aa00j13s01Service.jerarquiaChildren(filterAa00j13s01,
				jqGridRequestDto);
	}

	@RequestMapping(value = "/combo", method = RequestMethod.GET)
	public @ResponseBody
	List<Aa00j13s01> getCombo(
			@RequestParam(value = "aa00j13s01.aa00j03s01.cedif03", required = false) Long codEdificio) {
		return this.aa00j13s01Service.obtenerCombo(codEdificio);
	}

	@RequestMapping(value = "obtenerRecursosEdificio/{cedif03}", method = RequestMethod.POST)
	public @ResponseBody
	List<Aa00j13s01> obtenerRecursosEdificio(@PathVariable Long cedif03) {

		return this.aa00j13s01Service.obtenerRecursosEdificio(cedif03);
	}

	/**
	 * Method 'bloquear'.
	 * 
	 * @param crec13
	 *            Long
	 * @return boolean
	 */
	@RequestMapping(value = "bloquear/{crec13}", method = RequestMethod.POST)
	public @ResponseBody
	boolean bloquear(@PathVariable Long crec13) {

		return this.aa00j13s01Service.bloquear(crec13);
	}

	/**
	 * Method 'desbloquear'.
	 * 
	 * @param crec13
	 *            Long
	 * @return boolean
	 */
	@RequestMapping(value = "desbloquear/{crec13}", method = RequestMethod.POST)
	public @ResponseBody
	boolean desbloquear(@PathVariable Long crec13) {

		return this.aa00j13s01Service.desbloquear(crec13);
	}

	@RequestMapping(value = "obtenerRecursosEdificioReserva/{codReserva}", method = RequestMethod.POST)
	public @ResponseBody
	List<Aa00j13s01> obtenerRecursosEdificioReserva(
			@PathVariable Long codReserva) {

		return this.aa00j13s01Service
				.obtenerRecursosEdificioReserva(codReserva);
	}

	@RequestMapping(value = "obtenerRecursosEdificioReservaSala/{codReservaSala}", method = RequestMethod.POST)
	public @ResponseBody
	List<Aa00j13s01> obtenerRecursosEdificioReservaSala(
			@PathVariable Long codReservaSala) {

		return this.aa00j13s01Service
				.obtenerRecursosEdificioReservaSala(codReservaSala);
	}

	/**
	 * Iker Copia del get, pero le añade las características a la sala
	 * 
	 * @param crec13
	 *            Long
	 * @return Aa00j13s01 Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/recursocatacteristica/{crec13}", method = RequestMethod.GET)
	public @ResponseBody
	Aa00j13s01 getCaracteristicas(@PathVariable Long crec13) {
		Aa00j13s01 aa00j13s01 = new Aa00j13s01();
		aa00j13s01.setCrec13(crec13);
		aa00j13s01 = this.aa00j13s01Service.find(aa00j13s01);
		Aa00j13s01Controller.logger
				.info("[GET - findBy_PK] : Obtener Aa00j13s01 por PK");
		List<Aa00j14s01> caracteristicas = this.caracteristicasService
				.obtenerCaracteristicasRecurso(crec13);
		aa00j13s01.setAa00j14s01s(caracteristicas);
		return aa00j13s01;
	}

	/**
	 * Modifica la situacion de los registros ids en la tabla
	 * 
	 * @param ids
	 * @return
	 */
	@RequestMapping(value = "cambiarSituacion/{ids}", method = RequestMethod.POST)
	public @ResponseBody
	boolean cambiarSituacion(@PathVariable String ids) {
		return this.aa00j13s01Service.cambiarSituacion(ids);
	}

	@RequestMapping(value = "/excel", method = RequestMethod.POST)
	public String excel(Aa00j13s01 filterAa00j13s01,
			JQGridRequestDto jqGridRequestDto, int tipoSalida, Model model,
			Locale locale) {

		Aa00j13s01Controller.logger
				.info("[POST - filter] : Obtener Aa00j10s01s");
		if (filterAa00j13s01.getNome13().length() == 0)
			filterAa00j13s01.setNome13(null);
		List<Aa00j13s01> res = this.aa00j13s01Service.findAllLike(
				filterAa00j13s01, jqGridRequestDto, false);

		model.addAttribute("datos", res);
		String titulo = this.appMessageSource.getMessage("etListRecursos",
				null, LocaleContextHolder.getLocale());
		if (aa00jConstantes.TIPOEXCEL == tipoSalida) {
			model.addAttribute("titulo", titulo);
			return "excelView";
		} else {

			return locale.getLanguage() + "ListadoRecursos";
		}
	}

}